﻿using Infragistics.Controls.Schedules;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Controls.Primitives;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace SilverlightApplication1
{
    public partial class MainPage : UserControl
    {
        ObservableCollection<Resource> resources = new ObservableCollection<Resource>();
        ObservableCollection<ResourceCalendar> calendars = new ObservableCollection<ResourceCalendar>();
        ObservableCollection<Appointment> appointments = new ObservableCollection<Appointment>();
        ObservableCollection<Task> tasks = new ObservableCollection<Task>();

        public MainPage()
        {
            InitializeComponent();
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            resources.Add(new Resource
            {
                Id = "own1",
                Name = "Amanda"
            });


            calendars.Add(new ResourceCalendar
            {
                Id = "cal1",
                OwningResourceId = "own1"
            });


            appointments.Add(new Appointment
            {
                Id = "t1",
                OwningCalendarId = "cal1",
                OwningResourceId = "own1",
                Subject = "Appointment 1",
                Description = "My first appointment",
                Start = DateTime.Today.AddHours(9).AddMinutes(12),
                End = DateTime.Today.AddHours(11).AddMinutes(42)

            });


            tasks.Add(new Task
            {
                Id = "t0",
                OwningCalendarId = "cal1",
                OwningResourceId = "own1",
                Start = DateTime.Today.AddHours(9).AddMinutes(12).
                    ToUniversalTime(),
                End = DateTime.Today.AddHours(9).AddMinutes(42).
                    ToUniversalTime(),
                Subject = "Task1 1",
                Description = "My first Task in XAML",
            });

            dataConnector.TimeZoneInfoProviderResolved.LocalTimeZoneId = "UTC";
            dataConnector.ResourceItemsSource = resources;
            dataConnector.ResourceCalendarItemsSource = calendars;
            dataConnector.AppointmentItemsSource = appointments;
            dataConnector.TaskItemsSource = tasks;
        }

        private FrameworkElement GetChildFromName(DependencyObject parent, string name)
        {
            FrameworkElement result = null;

            for (int i = 0; i < VisualTreeHelper.GetChildrenCount(parent); i++)
            {
                if (VisualTreeHelper.GetChild(parent, i) is FrameworkElement
                    && (VisualTreeHelper.GetChild(parent, i) as FrameworkElement).Name.Equals(name))
                {
                    return VisualTreeHelper.GetChild(parent, i) as FrameworkElement;
                }
                else
                {
                    result = GetChildFromName(VisualTreeHelper.GetChild(parent, i), name);

                    if (result != null)
                    {
                        break;
                    }
                }
            }
            return result;
        }


        private void XamDayView1_SelectedTimeRangeChanged(object sender, Infragistics.Controls.NullableRoutedPropertyChangedEventArgs<Infragistics.DateRange> e)
        {
            Dispatcher.BeginInvoke(new Action(() =>
            {
                ScrollBar scrollBar = (ScrollBar)GetChildFromName(XamDayView1, "TimeslotScrollBar");
                scrollBar.ValueChanged += scrollBar_ValueChanged;
                scrollBar.Value = 50;
            }));
        }

        void scrollBar_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
        {
            double nowOffset = (DateTime.Now.Hour + 1) / 24.0;

            (sender as ScrollBar).Value = nowOffset * (sender as ScrollBar).Maximum;

        }
    }
}
